//
// MATLAB Compiler: 2.2
// Date: Tue May 28 11:08:59 2002
// Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
// "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
// "array_indexing:on" "-O" "optimize_conditionals:on" "-v" "-p" "-W" "main"
// "-L" "Cpp" "-t" "-T" "link:exe" "-h" "libmmfile.mlib" "match2fin" "circal.m" 
//
#include "jacobc.hpp"
#include "frames.hpp"
#include "libmatlbm.hpp"

static mxChar _array1_[130] = { 'R', 'u', 'n', '-', 't', 'i', 'm', 'e', ' ',
                                'E', 'r', 'r', 'o', 'r', ':', ' ', 'F', 'i',
                                'l', 'e', ':', ' ', 'j', 'a', 'c', 'o', 'b',
                                'c', ' ', 'L', 'i', 'n', 'e', ':', ' ', '1',
                                ' ', 'C', 'o', 'l', 'u', 'm', 'n', ':', ' ',
                                '1', ' ', 'T', 'h', 'e', ' ', 'f', 'u', 'n',
                                'c', 't', 'i', 'o', 'n', ' ', '"', 'j', 'a',
                                'c', 'o', 'b', 'c', '"', ' ', 'w', 'a', 's',
                                ' ', 'c', 'a', 'l', 'l', 'e', 'd', ' ', 'w',
                                'i', 't', 'h', ' ', 'm', 'o', 'r', 'e', ' ',
                                't', 'h', 'a', 'n', ' ', 't', 'h', 'e', ' ',
                                'd', 'e', 'c', 'l', 'a', 'r', 'e', 'd', ' ',
                                'n', 'u', 'm', 'b', 'e', 'r', ' ', 'o', 'f',
                                ' ', 'o', 'u', 't', 'p', 'u', 't', 's', ' ',
                                '(', '2', ')', '.' };
static mwArray _mxarray0_ = mclInitializeString(130, _array1_);

static mxChar _array3_[129] = { 'R', 'u', 'n', '-', 't', 'i', 'm', 'e', ' ',
                                'E', 'r', 'r', 'o', 'r', ':', ' ', 'F', 'i',
                                'l', 'e', ':', ' ', 'j', 'a', 'c', 'o', 'b',
                                'c', ' ', 'L', 'i', 'n', 'e', ':', ' ', '1',
                                ' ', 'C', 'o', 'l', 'u', 'm', 'n', ':', ' ',
                                '1', ' ', 'T', 'h', 'e', ' ', 'f', 'u', 'n',
                                'c', 't', 'i', 'o', 'n', ' ', '"', 'j', 'a',
                                'c', 'o', 'b', 'c', '"', ' ', 'w', 'a', 's',
                                ' ', 'c', 'a', 'l', 'l', 'e', 'd', ' ', 'w',
                                'i', 't', 'h', ' ', 'm', 'o', 'r', 'e', ' ',
                                't', 'h', 'a', 'n', ' ', 't', 'h', 'e', ' ',
                                'd', 'e', 'c', 'l', 'a', 'r', 'e', 'd', ' ',
                                'n', 'u', 'm', 'b', 'e', 'r', ' ', 'o', 'f',
                                ' ', 'i', 'n', 'p', 'u', 't', 's', ' ', '(',
                                '6', ')', '.' };
static mwArray _mxarray2_ = mclInitializeString(129, _array3_);
static mwArray _mxarray4_ = mclInitializeDouble(1e-10);
static mwArray _mxarray5_ = mclInitializeDouble(8.0);
static mwArray _mxarray6_ = mclInitializeDoubleVector(0, 0, (double *)NULL);
static mwArray _mxarray7_ = mclInitializeDouble(6.0);
static mwArray _mxarray8_ = mclInitializeDouble(1.0);
static mwArray _mxarray9_ = mclInitializeDouble(2.0);

void InitializeModule_jacobc() {
}

void TerminateModule_jacobc() {
}

static mwArray Mjacobc(mwArray * J,
                       int nargout_,
                       mwArray sys,
                       mwArray mod,
                       mwArray nbr,
                       mwArray p,
                       mwArray np,
                       mwArray cpar);

_mexLocalFunctionTable _local_function_table_jacobc
  = { 0, (mexFunctionTableEntry *)NULL };

//
// The function "jacobc" contains the normal interface for the "jacobc"
// M-function from file
// "c:\users\jedavis\src\ModelTrack\calib\heikkila\jacobc.m" (lines 1-58). This
// function processes any input arguments and passes them to the implementation
// version of the function, appearing above.
//
mwArray jacobc(mwArray * J,
               mwArray sys,
               mwArray mod,
               mwArray nbr,
               mwArray p,
               mwArray np,
               mwArray cpar) {
    int nargout(1);
    mwArray f(mclGetUninitializedArray());
    mwArray J__(mclGetUninitializedArray());
    if (J != NULL) {
        ++nargout;
    }
    f = Mjacobc(&J__, nargout, sys, mod, nbr, p, np, cpar);
    if (J != NULL) {
        *J = J__;
    }
    return f;
}

//
// The function "mlxJacobc" contains the feval interface for the "jacobc"
// M-function from file
// "c:\users\jedavis\src\ModelTrack\calib\heikkila\jacobc.m" (lines 1-58). The
// feval function calls the implementation version of jacobc through this
// function. This function processes any input arguments and passes them to the
// implementation version of the function, appearing above.
//
void mlxJacobc(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    MW_BEGIN_MLX();
    {
        mwArray mprhs[6];
        mwArray mplhs[2];
        int i;
        mclCppUninitializeArrays(2, mplhs);
        if (nlhs > 2) {
            error(_mxarray0_);
        }
        if (nrhs > 6) {
            error(_mxarray2_);
        }
        for (i = 0; i < 6 && i < nrhs; ++i) {
            mprhs[i] = mwArray(prhs[i], 0);
        }
        for (; i < 6; ++i) {
            mprhs[i].MakeDIN();
        }
        mplhs[0]
          = Mjacobc(
              &mplhs[1],
              nlhs,
              mprhs[0],
              mprhs[1],
              mprhs[2],
              mprhs[3],
              mprhs[4],
              mprhs[5]);
        plhs[0] = mplhs[0].FreezeData();
        for (i = 1; i < 2 && i < nlhs; ++i) {
            plhs[i] = mplhs[i].FreezeData();
        }
    }
    MW_END_MLX();
}

//
// The function "Mjacobc" is the implementation version of the "jacobc"
// M-function from file
// "c:\users\jedavis\src\ModelTrack\calib\heikkila\jacobc.m" (lines 1-58). It
// contains the actual compiled code for that M-function. It is a static
// function and must only be called from one of the interface functions,
// appearing below.
//
//
// function [f,J]=jacobc(sys,mod,nbr,p,np,cpar)
//
static mwArray Mjacobc(mwArray * J,
                       int nargout_,
                       mwArray sys,
                       mwArray mod,
                       mwArray nbr,
                       mwArray p,
                       mwArray np,
                       mwArray cpar) {
    mwLocalFunctionTable save_local_function_table_
      (&_local_function_table_jacobc);
    int nargin_(nargin(6, mwVarargin(sys, mod, nbr, p, np, cpar)));
    mwArray f(mclGetUninitializedArray());
    mwArray r(mclGetUninitializedArray());
    mwArray j(mclGetUninitializedArray());
    mwArray g(mclGetUninitializedArray());
    mwArray q(mclGetUninitializedArray());
    mwArray i(mclGetUninitializedArray());
    mwArray m(mclGetUninitializedArray());
    mwArray ind(mclGetUninitializedArray());
    mwArray t(mclGetUninitializedArray());
    mwArray n(mclGetUninitializedArray());
    mwArray delta(mclGetUninitializedArray());
    //
    // %JACOBC Evaluates the camera model and approximates the partial derivates
    // %with respect to the estimated parameters.
    // %3-D coordinates and camera parameters. 
    // %
    // %Usage:
    // %   [f,J]=jacobc(sys,mod,nbr,p)
    // %
    // %where       
    // %   sys  = system configuration information (see configc.m) 
    // %   mod  = matrix for the 3-D coordinates of the control points (n x 3)
    // %   nbr  = number of points per frame
    // %   p    = parameter vector (8+N*6 x 1)
    // %          p(1:8) contains the camera intrinsic parameters
    // %          p(9...) contains the camera position and orientation for
    // %          each N images. 
    // %   f    = synthetic image coordinates
    // %   J    = Jacobian matrix evaluated at p.
    // 
    // %   Version 2.1b  25.08.1998
    // %   Janne Heikkila, University of Oulu, Finland
    // 
    // delta=1e-10;
    //
    delta = _mxarray4_;
    //
    // if nargin==4
    //
    if (nargin_ == 4) {
        //
        // np=8;
        //
        np = _mxarray5_;
    //
    // end
    //
    }
    //
    // if nargin<6
    //
    if (nargin_ < 6) {
        //
        // cpar=[];
        //
        cpar = _mxarray6_;
    //
    // end
    //
    }
    //
    // 
    // n=length(p);
    //
    n = mclLengthInt(mwVa(p, "p"));
    //
    // t=(n-np)/6;
    //
    t = (mwVv(n, "n") - mwVa(np, "np")) / _mxarray7_;
    //
    // ind=[1 cumsum(nbr)+1];
    //
    ind
      = horzcat(
          mwVarargin(_mxarray8_, mwVe(cumsum(mwVa(nbr, "nbr"))) + _mxarray8_));
    //
    // f=frames(sys,mod,nbr,p,np,cpar);
    //
    f
      = frames(
          mwVa(sys, "sys"),
          mwVa(mod, "mod"),
          mwVa(nbr, "nbr"),
          mwVa(p, "p"),
          mwVa(np, "np"),
          mwVa(cpar, "cpar"));
    //
    // m=length(f)*2;
    //
    m = mclLengthInt(mwVv(f, "f")) * _mxarray9_;
    //
    // J=(zeros(m,n));
    //
    *J = zeros(mwVarargin(mwVv(m, "m"), mwVv(n, "n")));
    //
    // p=p(:);
    //
    p = mclArrayRef(mwVsa(p, "p"), colon());
    //
    // 
    // for i=1:np
    //
    {
        int v_(mclForIntStart(1));
        int e_(mclForIntEnd(mwVa(np, "np")));
        if (v_ > e_) {
            i = _mxarray6_;
        } else {
            //
            // q=p;
            // q(i)=q(i)+delta;
            // g=frames(sys,mod,nbr,q,np,cpar);
            // J(:,i)=(g(:)-f(:))/delta;
            // end
            //
            for (; ; ) {
                q = mwVsa(p, "p");
                mclIntArrayAssign(
                  &q,
                  mwVe(mclIntArrayRef(mwVsv(q, "q"), v_))
                  + mwVv(delta, "delta"),
                  v_);
                g
                  = frames(
                      mwVa(sys, "sys"),
                      mwVa(mod, "mod"),
                      mwVa(nbr, "nbr"),
                      mwVv(q, "q"),
                      mwVa(np, "np"),
                      mwVa(cpar, "cpar"));
                mclArrayAssign(
                  J,
                  (mwVe(mclArrayRef(mwVsv(g, "g"), colon()))
                   - mwVe(mclArrayRef(mwVsv(f, "f"), colon())))
                  / mwVv(delta, "delta"),
                  colon(),
                  v_);
                if (v_ == e_) {
                    break;
                }
                ++v_;
            }
            i = v_;
        }
    }
    //
    // 
    // for j=1:t
    //
    {
        int v_(mclForIntStart(1));
        int e_(mclForIntEnd(mwVv(t, "t")));
        if (v_ > e_) {
            j = _mxarray6_;
        } else {
            //
            // for i=1:6
            // q=[p(1:np);p(np+1+(j-1)*6:np+j*6)];
            // q(i+np)=q(i+np)+delta;
            // g=frames(sys,mod(ind(j):ind(j+1)-1,:),nbr(j),q,np,cpar);
            // r=f(ind(j):ind(j+1)-1,:);
            // J(ind(j):ind(j+1)-1,np+i+(j-1)*6)=(g(:,1)-r(:,1))/delta;
            // J(ind(j)+m/2:ind(j+1)-1+m/2,np+i+(j-1)*6)=(g(:,2)-r(:,2))/delta;
            // end
            // end
            //
            for (; ; ) {
                int v_0(mclForIntStart(1));
                int e_0(mclForIntEnd(_mxarray7_));
                if (v_0 > e_0) {
                    i = _mxarray6_;
                } else {
                    for (; ; ) {
                        q
                          = vertcat(
                              mwVarargin(
                                mwVe(
                                  mclArrayRef(
                                    mwVsa(p, "p"),
                                    colon(_mxarray8_, mwVa(np, "np")))),
                                mwVe(
                                  mclArrayRef(
                                    mwVsa(p, "p"),
                                    colon(
                                      mwVa(np, "np") + _mxarray8_
                                      + (v_ - 1) * _mxarray7_,
                                      mwVa(np, "np") + v_ * _mxarray7_)))));
                        mclArrayAssign(
                          &q,
                          mwVe(mclArrayRef(mwVsv(q, "q"), v_0 + mwVa(np, "np")))
                          + mwVv(delta, "delta"),
                          v_0 + mwVa(np, "np"));
                        g
                          = frames(
                              mwVa(sys, "sys"),
                              mwVe(
                                mclArrayRef(
                                  mwVsa(mod, "mod"),
                                  colon(
                                    mwVe(
                                      mclIntArrayRef(mwVsv(ind, "ind"), v_)),
                                    mwVe(
                                      mclIntArrayRef(
                                        mwVsv(ind, "ind"), v_ + 1))
                                    - _mxarray8_),
                                  colon())),
                              mwVe(mclIntArrayRef(mwVsa(nbr, "nbr"), v_)),
                              mwVv(q, "q"),
                              mwVa(np, "np"),
                              mwVa(cpar, "cpar"));
                        r
                          = mclArrayRef(
                              mwVsv(f, "f"),
                              colon(
                                mwVe(mclIntArrayRef(mwVsv(ind, "ind"), v_)),
                                mwVe(mclIntArrayRef(mwVsv(ind, "ind"), v_ + 1))
                                - _mxarray8_),
                              colon());
                        mclArrayAssign(
                          J,
                          (mwVe(mclArrayRef(mwVsv(g, "g"), colon(), _mxarray8_))
                           - mwVe(
                               mclArrayRef(
                                 mwVsv(r, "r"), colon(), _mxarray8_)))
                          / mwVv(delta, "delta"),
                          colon(
                            mwVe(mclIntArrayRef(mwVsv(ind, "ind"), v_)),
                            mwVe(mclIntArrayRef(mwVsv(ind, "ind"), v_ + 1))
                            - _mxarray8_),
                          mwVa(np, "np") + v_0 + (v_ - 1) * _mxarray7_);
                        mclArrayAssign(
                          J,
                          (mwVe(mclArrayRef(mwVsv(g, "g"), colon(), _mxarray9_))
                           - mwVe(
                               mclArrayRef(
                                 mwVsv(r, "r"), colon(), _mxarray9_)))
                          / mwVv(delta, "delta"),
                          colon(
                            mwVe(mclIntArrayRef(mwVsv(ind, "ind"), v_))
                            + mwVv(m, "m") / _mxarray9_,
                            mwVe(mclIntArrayRef(mwVsv(ind, "ind"), v_ + 1))
                            - _mxarray8_
                            + mwVv(m, "m") / _mxarray9_),
                          mwVa(np, "np") + v_0 + (v_ - 1) * _mxarray7_);
                        if (v_0 == e_0) {
                            break;
                        }
                        ++v_0;
                    }
                    i = v_0;
                }
                if (v_ == e_) {
                    break;
                }
                ++v_;
            }
            j = v_;
        }
    }
    //
    // J=sparse(J);
    //
    *J = sparse(mwVv(*J, "J"));
    //
    // f=f(:);
    //
    f = mclArrayRef(mwVsv(f, "f"), colon());
    mwValidateOutput(f, 1, nargout_, "f", "jacobc");
    mwValidateOutput(*J, 2, nargout_, "J", "jacobc");
    return f;
}
