/*
 * MATLAB Compiler: 2.2
 * Date: Fri Aug 02 18:10:55 2002
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-m" "-W" "main" "-L"
 * "C" "-t" "-T" "link:exe" "-h" "libmmfile.mlib" "xyzuvcal_both" 
 */

#ifndef MLF_V2
#define MLF_V2 1
#endif

#include "libmatlb.h"
#include "xyzuvcal_both.h"
#include "cacal.h"
#include "configc.h"
#include "invmodel.h"
#include "loadascii.h"
#include "saveascii.h"
#include "dlt.h"
#include "dlt2d.h"
#include "lmoptc.h"
#include "jacobc.h"
#include "frames.h"
#include "cmodel.h"
#include "libmmfile.h"

static mexFunctionTableEntry function_table[12]
  = { { "xyzuvcal_both", mlxXyzuvcal_both, 2, 1,
        &_local_function_table_xyzuvcal_both },
      { "cacal", mlxCacal, 7, 6, &_local_function_table_cacal },
      { "configc", mlxConfigc, 1, 1, &_local_function_table_configc },
      { "invmodel", mlxInvmodel, 2, 1, &_local_function_table_invmodel },
      { "loadascii", mlxLoadascii, 1, 1, &_local_function_table_loadascii },
      { "saveascii", mlxSaveascii, 2, 0, &_local_function_table_saveascii },
      { "dlt", mlxDlt, 2, 6, &_local_function_table_dlt },
      { "dlt2d", mlxDlt2d, 2, 6, &_local_function_table_dlt2d },
      { "lmoptc", mlxLmoptc, 6, 6, &_local_function_table_lmoptc },
      { "jacobc", mlxJacobc, 6, 2, &_local_function_table_jacobc },
      { "frames", mlxFrames, 6, 1, &_local_function_table_frames },
      { "cmodel", mlxCmodel, 4, 1, &_local_function_table_cmodel } };

static _mexInitTermTableEntry init_term_table[13]
  = { { libmmfileInitialize, libmmfileTerminate },
      { InitializeModule_xyzuvcal_both, TerminateModule_xyzuvcal_both },
      { InitializeModule_cacal, TerminateModule_cacal },
      { InitializeModule_configc, TerminateModule_configc },
      { InitializeModule_invmodel, TerminateModule_invmodel },
      { InitializeModule_loadascii, TerminateModule_loadascii },
      { InitializeModule_saveascii, TerminateModule_saveascii },
      { InitializeModule_dlt, TerminateModule_dlt },
      { InitializeModule_dlt2d, TerminateModule_dlt2d },
      { InitializeModule_lmoptc, TerminateModule_lmoptc },
      { InitializeModule_jacobc, TerminateModule_jacobc },
      { InitializeModule_frames, TerminateModule_frames },
      { InitializeModule_cmodel, TerminateModule_cmodel } };

static _mex_information _main_info
  = { 1, 12, function_table, 0, NULL, 0, NULL, 13, init_term_table };

/*
 * The function "main" is a Compiler-generated main wrapper, suitable for
 * building a stand-alone application.  It calls a library function to perform
 * initialization, call the main function, and perform library termination.
 */
int main(int argc, const char * * argv) {
    return mclMain(argc, argv, mlxXyzuvcal_both, 1, &_main_info);
}
