//###############################################################
// Random.h
// Kari Pulli
// 02/12/1996
//###############################################################

#ifndef _Random_h
#define _Random_h

#include <sys/types.h>
#include <time.h>
#include <stdlib.h>

class Random {
private:
  static long TimeSeed(void)
    { return (long) time(NULL); }
  
public:
  Random(unsigned long initSeed = TimeSeed())
    { srand(initSeed); }
  ~Random(void) {}

  void setSeed(unsigned long newSeed = TimeSeed())
    { srand(newSeed); }

  double operator()(double fact = 1.0)
    // return a random number [0.0,fact)
    { return fact*rand(); }
};

#endif
