//
// MATLAB Compiler: 2.2
// Date: Tue May 28 11:08:58 2002
// Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
// "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
// "array_indexing:on" "-O" "optimize_conditionals:on" "-v" "-p" "-W" "main"
// "-L" "Cpp" "-t" "-T" "link:exe" "-h" "libmmfile.mlib" "match2fin" "circal.m" 
//
#include "invmodel.hpp"
#include "configc.hpp"
#include "libmatlbm.hpp"
#include "libmmfile.hpp"

static mxChar _array1_[134] = { 'R', 'u', 'n', '-', 't', 'i', 'm', 'e', ' ',
                                'E', 'r', 'r', 'o', 'r', ':', ' ', 'F', 'i',
                                'l', 'e', ':', ' ', 'i', 'n', 'v', 'm', 'o',
                                'd', 'e', 'l', ' ', 'L', 'i', 'n', 'e', ':',
                                ' ', '1', ' ', 'C', 'o', 'l', 'u', 'm', 'n',
                                ':', ' ', '1', ' ', 'T', 'h', 'e', ' ', 'f',
                                'u', 'n', 'c', 't', 'i', 'o', 'n', ' ', '"',
                                'i', 'n', 'v', 'm', 'o', 'd', 'e', 'l', '"',
                                ' ', 'w', 'a', 's', ' ', 'c', 'a', 'l', 'l',
                                'e', 'd', ' ', 'w', 'i', 't', 'h', ' ', 'm',
                                'o', 'r', 'e', ' ', 't', 'h', 'a', 'n', ' ',
                                't', 'h', 'e', ' ', 'd', 'e', 'c', 'l', 'a',
                                'r', 'e', 'd', ' ', 'n', 'u', 'm', 'b', 'e',
                                'r', ' ', 'o', 'f', ' ', 'o', 'u', 't', 'p',
                                'u', 't', 's', ' ', '(', '1', ')', '.' };
static mwArray _mxarray0_ = mclInitializeString(134, _array1_);

static mxChar _array3_[133] = { 'R', 'u', 'n', '-', 't', 'i', 'm', 'e', ' ',
                                'E', 'r', 'r', 'o', 'r', ':', ' ', 'F', 'i',
                                'l', 'e', ':', ' ', 'i', 'n', 'v', 'm', 'o',
                                'd', 'e', 'l', ' ', 'L', 'i', 'n', 'e', ':',
                                ' ', '1', ' ', 'C', 'o', 'l', 'u', 'm', 'n',
                                ':', ' ', '1', ' ', 'T', 'h', 'e', ' ', 'f',
                                'u', 'n', 'c', 't', 'i', 'o', 'n', ' ', '"',
                                'i', 'n', 'v', 'm', 'o', 'd', 'e', 'l', '"',
                                ' ', 'w', 'a', 's', ' ', 'c', 'a', 'l', 'l',
                                'e', 'd', ' ', 'w', 'i', 't', 'h', ' ', 'm',
                                'o', 'r', 'e', ' ', 't', 'h', 'a', 'n', ' ',
                                't', 'h', 'e', ' ', 'd', 'e', 'c', 'l', 'a',
                                'r', 'e', 'd', ' ', 'n', 'u', 'm', 'b', 'e',
                                'r', ' ', 'o', 'f', ' ', 'i', 'n', 'p', 'u',
                                't', 's', ' ', '(', '2', ')', '.' };
static mwArray _mxarray2_ = mclInitializeString(133, _array3_);
static mwArray _mxarray4_ = mclInitializeDouble(1.1);
static mwArray _mxarray5_ = mclInitializeDouble(40.0);
static mwArray _mxarray6_ = mclInitializeDouble(1.0);
static mwArray _mxarray7_ = mclInitializeDouble(2.0);
static mwArray _mxarray8_ = mclInitializeDouble(-2.0);

void InitializeModule_invmodel() {
}

void TerminateModule_invmodel() {
}

static mwArray Minvmodel(int nargout_, mwArray name, mwArray par);

_mexLocalFunctionTable _local_function_table_invmodel
  = { 0, (mexFunctionTableEntry *)NULL };

//
// The function "invmodel" contains the normal interface for the "invmodel"
// M-function from file
// "c:\users\jedavis\src\ModelTrack\calib\heikkila\invmodel.m" (lines 1-49).
// This function processes any input arguments and passes them to the
// implementation version of the function, appearing above.
//
mwArray invmodel(mwArray name, mwArray par) {
    int nargout(1);
    mwArray a(mclGetUninitializedArray());
    a = Minvmodel(nargout, name, par);
    return a;
}

//
// The function "mlxInvmodel" contains the feval interface for the "invmodel"
// M-function from file
// "c:\users\jedavis\src\ModelTrack\calib\heikkila\invmodel.m" (lines 1-49).
// The feval function calls the implementation version of invmodel through this
// function. This function processes any input arguments and passes them to the
// implementation version of the function, appearing above.
//
void mlxInvmodel(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    MW_BEGIN_MLX();
    {
        mwArray mprhs[2];
        mwArray mplhs[1];
        int i;
        mclCppUninitializeArrays(1, mplhs);
        if (nlhs > 1) {
            error(_mxarray0_);
        }
        if (nrhs > 2) {
            error(_mxarray2_);
        }
        for (i = 0; i < 2 && i < nrhs; ++i) {
            mprhs[i] = mwArray(prhs[i], 0);
        }
        for (; i < 2; ++i) {
            mprhs[i].MakeDIN();
        }
        mplhs[0] = Minvmodel(nlhs, mprhs[0], mprhs[1]);
        plhs[0] = mplhs[0].FreezeData();
    }
    MW_END_MLX();
}

//
// The function "Minvmodel" is the implementation version of the "invmodel"
// M-function from file
// "c:\users\jedavis\src\ModelTrack\calib\heikkila\invmodel.m" (lines 1-49). It
// contains the actual compiled code for that M-function. It is a static
// function and must only be called from one of the interface functions,
// appearing below.
//
//
// function a=invmodel(name,par)
//
static mwArray Minvmodel(int nargout_, mwArray name, mwArray par) {
    mwLocalFunctionTable save_local_function_table_
      (&_local_function_table_invmodel);
    mwArray a(mclGetUninitializedArray());
    mwArray e(mclGetUninitializedArray());
    mwArray T(mclGetUninitializedArray());
    mwArray Ty(mclGetUninitializedArray());
    mwArray Tx(mclGetUninitializedArray());
    mwArray dy(mclGetUninitializedArray());
    mwArray dx(mclGetUninitializedArray());
    mwArray delta(mclGetUninitializedArray());
    mwArray r2(mclGetUninitializedArray());
    mwArray cy(mclGetUninitializedArray());
    mwArray cx(mclGetUninitializedArray());
    mwArray py(mclGetUninitializedArray());
    mwArray px(mclGetUninitializedArray());
    mwArray ye(mclGetUninitializedArray());
    mwArray ys(mclGetUninitializedArray());
    mwArray xe(mclGetUninitializedArray());
    mwArray xs(mclGetUninitializedArray());
    mwArray cpy(mclGetUninitializedArray());
    mwArray cpx(mclGetUninitializedArray());
    mwArray Tan2(mclGetUninitializedArray());
    mwArray Tan1(mclGetUninitializedArray());
    mwArray Rad2(mclGetUninitializedArray());
    mwArray Rad1(mclGetUninitializedArray());
    mwArray Cpy(mclGetUninitializedArray());
    mwArray Cpx(mclGetUninitializedArray());
    mwArray Foc(mclGetUninitializedArray());
    mwArray Asp(mclGetUninitializedArray());
    mwArray Sy(mclGetUninitializedArray());
    mwArray Sx(mclGetUninitializedArray());
    mwArray NDY(mclGetUninitializedArray());
    mwArray NDX(mclGetUninitializedArray());
    mwArray sys(mclGetUninitializedArray());
    //
    // %INVMODEL calculates the parameters of the inverse camera model, which
    // %can be used to correct measured image coordinates to correspond a simple
    // %pinhole model.
    // %
    // %Usage:
    // %   a=invmodel(name,par)
    // %
    // %where
    // %   name = string that is specific to the camera and the framegrabber.
    // %          This string must be defined in configc.m
    // %   par  = camera intrinsic parameters
    // %   a    = eight implicit parameters of the inverse camera model
    // 
    // %   Version 2.0  15.5.-97
    // %   Janne Heikkila, University of Oulu, Finland
    // 
    // sys=configc(name);
    //
    sys = configc(mwVa(name, "name"));
    //
    // NDX=sys(1); NDY=sys(2); Sx=sys(3); Sy=sys(4);
    //
    NDX = mclIntArrayRef(mwVsv(sys, "sys"), 1);
    NDY = mclIntArrayRef(mwVsv(sys, "sys"), 2);
    Sx = mclIntArrayRef(mwVsv(sys, "sys"), 3);
    Sy = mclIntArrayRef(mwVsv(sys, "sys"), 4);
    //
    // Asp=par(1); Foc=par(2);
    //
    Asp = mclIntArrayRef(mwVsa(par, "par"), 1);
    Foc = mclIntArrayRef(mwVsa(par, "par"), 2);
    //
    // Cpx=par(3); Cpy=par(4);
    //
    Cpx = mclIntArrayRef(mwVsa(par, "par"), 3);
    Cpy = mclIntArrayRef(mwVsa(par, "par"), 4);
    //
    // Rad1=par(5); Rad2=par(6);
    //
    Rad1 = mclIntArrayRef(mwVsa(par, "par"), 5);
    Rad2 = mclIntArrayRef(mwVsa(par, "par"), 6);
    //
    // Tan1=par(7); Tan2=par(8);
    //
    Tan1 = mclIntArrayRef(mwVsa(par, "par"), 7);
    Tan2 = mclIntArrayRef(mwVsa(par, "par"), 8);
    //
    // 
    // cpx=Cpx/NDX*Sx/Asp;
    //
    cpx
      = mwVv(Cpx, "Cpx") / mwVv(NDX, "NDX") * mwVv(Sx, "Sx")
        / mwVv(Asp, "Asp");
    //
    // cpy=Cpy/NDY*Sy;
    //
    cpy = mwVv(Cpy, "Cpy") / mwVv(NDY, "NDY") * mwVv(Sy, "Sy");
    //
    // 
    // xs=-cpx*1.1; xe=(Sx-cpx)*1.1;
    //
    xs = - mwVv(cpx, "cpx") * _mxarray4_;
    xe = (mwVv(Sx, "Sx") - mwVv(cpx, "cpx")) * _mxarray4_;
    //
    // ys=-cpy*1.1; ye=(Sy-cpy)*1.1;
    //
    ys = - mwVv(cpy, "cpy") * _mxarray4_;
    ye = (mwVv(Sy, "Sy") - mwVv(cpy, "cpy")) * _mxarray4_;
    //
    // px=Sx/40; py=Sy/40;
    //
    px = mwVv(Sx, "Sx") / _mxarray5_;
    py = mwVv(Sy, "Sy") / _mxarray5_;
    //
    // 
    // [cx,cy]=meshgrid(xs:px:xe,ye:-py:ys); cx=cx(:); cy=cy(:);
    //
    cx
    = Nmeshgrid(
        2,
        &cy,
        NULL,
        colon(mwVv(xs, "xs"), mwVv(px, "px"), mwVv(xe, "xe")),
        colon(mwVv(ye, "ye"), - mwVv(py, "py"), mwVv(ys, "ys")));
    cx = mclArrayRef(mwVsv(cx, "cx"), colon());
    cy = mclArrayRef(mwVsv(cy, "cy"), colon());
    //
    // r2=cx.*cx+cy.*cy;
    //
    r2
      = times(mwVv(cx, "cx"), mwVv(cx, "cx"))
        + times(mwVv(cy, "cy"), mwVv(cy, "cy"));
    //
    // delta=Rad1*r2+Rad2*r2.*r2;
    //
    delta
      = mwVv(Rad1, "Rad1") * mwVv(r2, "r2")
        + times(mwVv(Rad2, "Rad2") * mwVv(r2, "r2"), mwVv(r2, "r2"));
    //
    // 
    // dx=cx.*(1+delta)+2*Tan1*cx.*cy+Tan2*(r2+2*cx.*cx); 
    //
    dx
      = times(mwVv(cx, "cx"), _mxarray6_ + mwVv(delta, "delta"))
        + times(
            _mxarray7_ * mwVv(Tan1, "Tan1") * mwVv(cx, "cx"), mwVv(cy, "cy"))
        + mwVv(Tan2, "Tan2")
          * (mwVv(r2, "r2")
             + times(_mxarray7_ * mwVv(cx, "cx"), mwVv(cx, "cx")));
    //
    // dy=cy.*(1+delta)+Tan1*(r2+2*cy.*cy)+2*Tan2*cx.*cy; 
    //
    dy
      = times(mwVv(cy, "cy"), _mxarray6_ + mwVv(delta, "delta"))
        + mwVv(Tan1, "Tan1")
          * (mwVv(r2, "r2")
             + times(_mxarray7_ * mwVv(cy, "cy"), mwVv(cy, "cy")))
        + times(
            _mxarray7_ * mwVv(Tan2, "Tan2") * mwVv(cx, "cx"), mwVv(cy, "cy"));
    //
    // 
    // r2=dx.*dx+dy.*dy;
    //
    r2
      = times(mwVv(dx, "dx"), mwVv(dx, "dx"))
        + times(mwVv(dy, "dy"), mwVv(dy, "dy"));
    //
    // 
    // Tx=[-dx.*r2 -dx.*r2.^2 -2*dx.*dy -(r2+2*dx.^2) cx.*r2.^2 cx.*dx.*r2 ...
    //
    Tx
      = horzcat(
          mwVarargin(
            times(- mwVv(dx, "dx"), mwVv(r2, "r2")),
            times(- mwVv(dx, "dx"), power(mwVv(r2, "r2"), _mxarray7_)),
            times(_mxarray8_ * mwVv(dx, "dx"), mwVv(dy, "dy")),
            - (mwVv(r2, "r2")
               + _mxarray7_ * power(mwVv(dx, "dx"), _mxarray7_)),
            times(mwVv(cx, "cx"), power(mwVv(r2, "r2"), _mxarray7_)),
            times(times(mwVv(cx, "cx"), mwVv(dx, "dx")), mwVv(r2, "r2")),
            times(times(mwVv(dy, "dy"), mwVv(cx, "cx")), mwVv(r2, "r2")),
            times(mwVv(cx, "cx"), mwVv(r2, "r2"))));
    //
    // dy.*cx.*r2 cx.*r2];
    // Ty=[-dy.*r2 -dy.*r2.^2 -(r2+2*dy.^2) -2*dx.*dy cy.*r2.^2 cy.*dx.*r2 ...
    //
    Ty
      = horzcat(
          mwVarargin(
            times(- mwVv(dy, "dy"), mwVv(r2, "r2")),
            times(- mwVv(dy, "dy"), power(mwVv(r2, "r2"), _mxarray7_)),
            - (mwVv(r2, "r2")
               + _mxarray7_ * power(mwVv(dy, "dy"), _mxarray7_)),
            times(_mxarray8_ * mwVv(dx, "dx"), mwVv(dy, "dy")),
            times(mwVv(cy, "cy"), power(mwVv(r2, "r2"), _mxarray7_)),
            times(times(mwVv(cy, "cy"), mwVv(dx, "dx")), mwVv(r2, "r2")),
            times(times(mwVv(cy, "cy"), mwVv(dy, "dy")), mwVv(r2, "r2")),
            times(mwVv(cy, "cy"), mwVv(r2, "r2"))));
    //
    // cy.*dy.*r2 cy.*r2];
    // T=[Tx;Ty];
    //
    T = vertcat(mwVarargin(mwVv(Tx, "Tx"), mwVv(Ty, "Ty")));
    //
    // e=[dx-cx;dy-cy];
    //
    e
      = vertcat(
          mwVarargin(
            mwVv(dx, "dx") - mwVv(cx, "cx"), mwVv(dy, "dy") - mwVv(cy, "cy")));
    //
    // a=pinv(T)*e;
    //
    a = mwVe(pinv(mwVv(T, "T"), mwVarargin())) * mwVv(e, "e");
    mwValidateOutput(a, 1, nargout_, "a", "invmodel");
    return a;
    //
    // 
    //
}
