/*
 * MATLAB Compiler: 2.2
 * Date: Mon Aug 05 10:08:43 2002
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-m" "-W" "main" "-L"
 * "C" "-t" "-T" "link:exe" "-h" "libmmfile.mlib" "xyzuvcal_extonly" 
 */
#include "jacobc.h"
#include "frames.h"
#include "libmatlbm.h"

static mxChar _array1_[130] = { 'R', 'u', 'n', '-', 't', 'i', 'm', 'e', ' ',
                                'E', 'r', 'r', 'o', 'r', ':', ' ', 'F', 'i',
                                'l', 'e', ':', ' ', 'j', 'a', 'c', 'o', 'b',
                                'c', ' ', 'L', 'i', 'n', 'e', ':', ' ', '1',
                                ' ', 'C', 'o', 'l', 'u', 'm', 'n', ':', ' ',
                                '1', ' ', 'T', 'h', 'e', ' ', 'f', 'u', 'n',
                                'c', 't', 'i', 'o', 'n', ' ', '"', 'j', 'a',
                                'c', 'o', 'b', 'c', '"', ' ', 'w', 'a', 's',
                                ' ', 'c', 'a', 'l', 'l', 'e', 'd', ' ', 'w',
                                'i', 't', 'h', ' ', 'm', 'o', 'r', 'e', ' ',
                                't', 'h', 'a', 'n', ' ', 't', 'h', 'e', ' ',
                                'd', 'e', 'c', 'l', 'a', 'r', 'e', 'd', ' ',
                                'n', 'u', 'm', 'b', 'e', 'r', ' ', 'o', 'f',
                                ' ', 'o', 'u', 't', 'p', 'u', 't', 's', ' ',
                                '(', '2', ')', '.' };
static mxArray * _mxarray0_;

static mxChar _array3_[129] = { 'R', 'u', 'n', '-', 't', 'i', 'm', 'e', ' ',
                                'E', 'r', 'r', 'o', 'r', ':', ' ', 'F', 'i',
                                'l', 'e', ':', ' ', 'j', 'a', 'c', 'o', 'b',
                                'c', ' ', 'L', 'i', 'n', 'e', ':', ' ', '1',
                                ' ', 'C', 'o', 'l', 'u', 'm', 'n', ':', ' ',
                                '1', ' ', 'T', 'h', 'e', ' ', 'f', 'u', 'n',
                                'c', 't', 'i', 'o', 'n', ' ', '"', 'j', 'a',
                                'c', 'o', 'b', 'c', '"', ' ', 'w', 'a', 's',
                                ' ', 'c', 'a', 'l', 'l', 'e', 'd', ' ', 'w',
                                'i', 't', 'h', ' ', 'm', 'o', 'r', 'e', ' ',
                                't', 'h', 'a', 'n', ' ', 't', 'h', 'e', ' ',
                                'd', 'e', 'c', 'l', 'a', 'r', 'e', 'd', ' ',
                                'n', 'u', 'm', 'b', 'e', 'r', ' ', 'o', 'f',
                                ' ', 'i', 'n', 'p', 'u', 't', 's', ' ', '(',
                                '6', ')', '.' };
static mxArray * _mxarray2_;
static mxArray * _mxarray4_;
static mxArray * _mxarray5_;
static mxArray * _mxarray6_;
static mxArray * _mxarray7_;
static mxArray * _mxarray8_;
static mxArray * _mxarray9_;

void InitializeModule_jacobc(void) {
    _mxarray0_ = mclInitializeString(130, _array1_);
    _mxarray2_ = mclInitializeString(129, _array3_);
    _mxarray4_ = mclInitializeDouble(1e-10);
    _mxarray5_ = mclInitializeDouble(8.0);
    _mxarray6_ = mclInitializeDoubleVector(0, 0, (double *)NULL);
    _mxarray7_ = mclInitializeDouble(6.0);
    _mxarray8_ = mclInitializeDouble(1.0);
    _mxarray9_ = mclInitializeDouble(2.0);
}

void TerminateModule_jacobc(void) {
    mxDestroyArray(_mxarray9_);
    mxDestroyArray(_mxarray8_);
    mxDestroyArray(_mxarray7_);
    mxDestroyArray(_mxarray6_);
    mxDestroyArray(_mxarray5_);
    mxDestroyArray(_mxarray4_);
    mxDestroyArray(_mxarray2_);
    mxDestroyArray(_mxarray0_);
}

static mxArray * Mjacobc(mxArray * * J,
                         int nargout_,
                         mxArray * sys,
                         mxArray * mod,
                         mxArray * nbr,
                         mxArray * p,
                         mxArray * np,
                         mxArray * cpar);

_mexLocalFunctionTable _local_function_table_jacobc
  = { 0, (mexFunctionTableEntry *)NULL };

/*
 * The function "mlfJacobc" contains the normal interface for the "jacobc"
 * M-function from file
 * "c:\users\jedavis\src\ModelTrack\calib\heikkila\jacobc.m" (lines 1-58). This
 * function processes any input arguments and passes them to the implementation
 * version of the function, appearing above.
 */
mxArray * mlfJacobc(mxArray * * J,
                    mxArray * sys,
                    mxArray * mod,
                    mxArray * nbr,
                    mxArray * p,
                    mxArray * np,
                    mxArray * cpar) {
    int nargout = 1;
    mxArray * f = mclGetUninitializedArray();
    mxArray * J__ = mclGetUninitializedArray();
    mlfEnterNewContext(1, 6, J, sys, mod, nbr, p, np, cpar);
    if (J != NULL) {
        ++nargout;
    }
    f = Mjacobc(&J__, nargout, sys, mod, nbr, p, np, cpar);
    mlfRestorePreviousContext(1, 6, J, sys, mod, nbr, p, np, cpar);
    if (J != NULL) {
        mclCopyOutputArg(J, J__);
    } else {
        mxDestroyArray(J__);
    }
    return mlfReturnValue(f);
}

/*
 * The function "mlxJacobc" contains the feval interface for the "jacobc"
 * M-function from file
 * "c:\users\jedavis\src\ModelTrack\calib\heikkila\jacobc.m" (lines 1-58). The
 * feval function calls the implementation version of jacobc through this
 * function. This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
void mlxJacobc(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[6];
    mxArray * mplhs[2];
    int i;
    if (nlhs > 2) {
        mlfError(_mxarray0_);
    }
    if (nrhs > 6) {
        mlfError(_mxarray2_);
    }
    for (i = 0; i < 2; ++i) {
        mplhs[i] = mclGetUninitializedArray();
    }
    for (i = 0; i < 6 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 6; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(
      0, 6, mprhs[0], mprhs[1], mprhs[2], mprhs[3], mprhs[4], mprhs[5]);
    mplhs[0]
      = Mjacobc(
          &mplhs[1],
          nlhs,
          mprhs[0],
          mprhs[1],
          mprhs[2],
          mprhs[3],
          mprhs[4],
          mprhs[5]);
    mlfRestorePreviousContext(
      0, 6, mprhs[0], mprhs[1], mprhs[2], mprhs[3], mprhs[4], mprhs[5]);
    plhs[0] = mplhs[0];
    for (i = 1; i < 2 && i < nlhs; ++i) {
        plhs[i] = mplhs[i];
    }
    for (; i < 2; ++i) {
        mxDestroyArray(mplhs[i]);
    }
}

/*
 * The function "Mjacobc" is the implementation version of the "jacobc"
 * M-function from file
 * "c:\users\jedavis\src\ModelTrack\calib\heikkila\jacobc.m" (lines 1-58). It
 * contains the actual compiled code for that M-function. It is a static
 * function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function [f,J]=jacobc(sys,mod,nbr,p,np,cpar)
 */
static mxArray * Mjacobc(mxArray * * J,
                         int nargout_,
                         mxArray * sys,
                         mxArray * mod,
                         mxArray * nbr,
                         mxArray * p,
                         mxArray * np,
                         mxArray * cpar) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(&_local_function_table_jacobc);
    int nargin_ = mclNargin(6, sys, mod, nbr, p, np, cpar, NULL);
    mxArray * f = mclGetUninitializedArray();
    mxArray * r = mclGetUninitializedArray();
    mxArray * j = mclGetUninitializedArray();
    mxArray * g = mclGetUninitializedArray();
    mxArray * q = mclGetUninitializedArray();
    mxArray * i = mclGetUninitializedArray();
    mxArray * m = mclGetUninitializedArray();
    mxArray * ind = mclGetUninitializedArray();
    mxArray * t = mclGetUninitializedArray();
    mxArray * n = mclGetUninitializedArray();
    mxArray * delta = mclGetUninitializedArray();
    mclCopyArray(&sys);
    mclCopyArray(&mod);
    mclCopyArray(&nbr);
    mclCopyArray(&p);
    mclCopyArray(&np);
    mclCopyArray(&cpar);
    /*
     * %JACOBC Evaluates the camera model and approximates the partial derivates
     * %with respect to the estimated parameters.
     * %3-D coordinates and camera parameters. 
     * %
     * %Usage:
     * %   [f,J]=jacobc(sys,mod,nbr,p)
     * %
     * %where       
     * %   sys  = system configuration information (see configc.m) 
     * %   mod  = matrix for the 3-D coordinates of the control points (n x 3)
     * %   nbr  = number of points per frame
     * %   p    = parameter vector (8+N*6 x 1)
     * %          p(1:8) contains the camera intrinsic parameters
     * %          p(9...) contains the camera position and orientation for
     * %          each N images. 
     * %   f    = synthetic image coordinates
     * %   J    = Jacobian matrix evaluated at p.
     * 
     * %   Version 2.1b  25.08.1998
     * %   Janne Heikkila, University of Oulu, Finland
     * 
     * delta=1e-10;
     */
    mlfAssign(&delta, _mxarray4_);
    /*
     * if nargin==4
     */
    if (nargin_ == 4) {
        /*
         * np=8;
         */
        mlfAssign(&np, _mxarray5_);
    /*
     * end
     */
    }
    /*
     * if nargin<6
     */
    if (nargin_ < 6) {
        /*
         * cpar=[];
         */
        mlfAssign(&cpar, _mxarray6_);
    /*
     * end
     */
    }
    /*
     * 
     * n=length(p);
     */
    mlfAssign(&n, mlfScalar(mclLengthInt(mclVa(p, "p"))));
    /*
     * t=(n-np)/6;
     */
    mlfAssign(
      &t, mclMrdivide(mclMinus(mclVv(n, "n"), mclVa(np, "np")), _mxarray7_));
    /*
     * ind=[1 cumsum(nbr)+1];
     */
    mlfAssign(
      &ind,
      mlfHorzcat(
        _mxarray8_,
        mclPlus(mclVe(mlfCumsum(mclVa(nbr, "nbr"), NULL)), _mxarray8_),
        NULL));
    /*
     * f=frames(sys,mod,nbr,p,np,cpar);
     */
    mlfAssign(
      &f,
      mlfFrames(
        mclVa(sys, "sys"),
        mclVa(mod, "mod"),
        mclVa(nbr, "nbr"),
        mclVa(p, "p"),
        mclVa(np, "np"),
        mclVa(cpar, "cpar")));
    /*
     * m=length(f)*2;
     */
    mlfAssign(
      &m, mclMtimes(mlfScalar(mclLengthInt(mclVv(f, "f"))), _mxarray9_));
    /*
     * J=(zeros(m,n));
     */
    mlfAssign(J, mlfZeros(mclVv(m, "m"), mclVv(n, "n"), NULL));
    /*
     * p=p(:);
     */
    mlfAssign(&p, mclArrayRef1(mclVsa(p, "p"), mlfCreateColonIndex()));
    /*
     * 
     * for i=1:np
     */
    {
        int v_ = mclForIntStart(1);
        int e_ = mclForIntEnd(mclVa(np, "np"));
        if (v_ > e_) {
            mlfAssign(&i, _mxarray6_);
        } else {
            /*
             * q=p;
             * q(i)=q(i)+delta;
             * g=frames(sys,mod,nbr,q,np,cpar);
             * J(:,i)=(g(:)-f(:))/delta;
             * end
             */
            for (; ; ) {
                mlfAssign(&q, mclVsa(p, "p"));
                mclIntArrayAssign1(
                  &q,
                  mclPlus(
                    mclVe(mclIntArrayRef1(mclVsv(q, "q"), v_)),
                    mclVv(delta, "delta")),
                  v_);
                mlfAssign(
                  &g,
                  mlfFrames(
                    mclVa(sys, "sys"),
                    mclVa(mod, "mod"),
                    mclVa(nbr, "nbr"),
                    mclVv(q, "q"),
                    mclVa(np, "np"),
                    mclVa(cpar, "cpar")));
                mclArrayAssign2(
                  J,
                  mclMrdivide(
                    mclMinus(
                      mclVe(
                        mclArrayRef1(mclVsv(g, "g"), mlfCreateColonIndex())),
                      mclVe(
                        mclArrayRef1(mclVsv(f, "f"), mlfCreateColonIndex()))),
                    mclVv(delta, "delta")),
                  mlfCreateColonIndex(),
                  mlfScalar(v_));
                if (v_ == e_) {
                    break;
                }
                ++v_;
            }
            mlfAssign(&i, mlfScalar(v_));
        }
    }
    /*
     * 
     * for j=1:t
     */
    {
        int v_ = mclForIntStart(1);
        int e_ = mclForIntEnd(mclVv(t, "t"));
        if (v_ > e_) {
            mlfAssign(&j, _mxarray6_);
        } else {
            /*
             * for i=1:6
             * q=[p(1:np);p(np+1+(j-1)*6:np+j*6)];
             * q(i+np)=q(i+np)+delta;
             * g=frames(sys,mod(ind(j):ind(j+1)-1,:),nbr(j),q,np,cpar);
             * r=f(ind(j):ind(j+1)-1,:);
             * J(ind(j):ind(j+1)-1,np+i+(j-1)*6)=(g(:,1)-r(:,1))/delta;
             * J(ind(j)+m/2:ind(j+1)-1+m/2,np+i+(j-1)*6)=(g(:,2)-r(:,2))/delta;
             * end
             * end
             */
            for (; ; ) {
                int v_0 = mclForIntStart(1);
                int e_0 = mclForIntEnd(_mxarray7_);
                if (v_0 > e_0) {
                    mlfAssign(&i, _mxarray6_);
                } else {
                    for (; ; ) {
                        mlfAssign(
                          &q,
                          mlfVertcat(
                            mclVe(
                              mclArrayRef1(
                                mclVsa(p, "p"),
                                mlfColon(_mxarray8_, mclVa(np, "np"), NULL))),
                            mclVe(
                              mclArrayRef1(
                                mclVsa(p, "p"),
                                mlfColon(
                                  mclPlus(
                                    mclPlus(mclVa(np, "np"), _mxarray8_),
                                    mclMtimes(mlfScalar(v_ - 1), _mxarray7_)),
                                  mclPlus(
                                    mclVa(np, "np"),
                                    mclMtimes(mlfScalar(v_), _mxarray7_)),
                                  NULL))),
                            NULL));
                        mclArrayAssign1(
                          &q,
                          mclPlus(
                            mclVe(
                              mclArrayRef1(
                                mclVsv(q, "q"),
                                mclPlus(mlfScalar(v_0), mclVa(np, "np")))),
                            mclVv(delta, "delta")),
                          mclPlus(mlfScalar(v_0), mclVa(np, "np")));
                        mlfAssign(
                          &g,
                          mlfFrames(
                            mclVa(sys, "sys"),
                            mclVe(
                              mclArrayRef2(
                                mclVsa(mod, "mod"),
                                mlfColon(
                                  mclVe(
                                    mclIntArrayRef1(mclVsv(ind, "ind"), v_)),
                                  mclMinus(
                                    mclVe(
                                      mclIntArrayRef1(
                                        mclVsv(ind, "ind"), v_ + 1)),
                                    _mxarray8_),
                                  NULL),
                                mlfCreateColonIndex())),
                            mclVe(mclIntArrayRef1(mclVsa(nbr, "nbr"), v_)),
                            mclVv(q, "q"),
                            mclVa(np, "np"),
                            mclVa(cpar, "cpar")));
                        mlfAssign(
                          &r,
                          mclArrayRef2(
                            mclVsv(f, "f"),
                            mlfColon(
                              mclVe(mclIntArrayRef1(mclVsv(ind, "ind"), v_)),
                              mclMinus(
                                mclVe(
                                  mclIntArrayRef1(mclVsv(ind, "ind"), v_ + 1)),
                                _mxarray8_),
                              NULL),
                            mlfCreateColonIndex()));
                        mclArrayAssign2(
                          J,
                          mclMrdivide(
                            mclMinus(
                              mclVe(
                                mclArrayRef2(
                                  mclVsv(g, "g"),
                                  mlfCreateColonIndex(),
                                  _mxarray8_)),
                              mclVe(
                                mclArrayRef2(
                                  mclVsv(r, "r"),
                                  mlfCreateColonIndex(),
                                  _mxarray8_))),
                            mclVv(delta, "delta")),
                          mlfColon(
                            mclVe(mclIntArrayRef1(mclVsv(ind, "ind"), v_)),
                            mclMinus(
                              mclVe(
                                mclIntArrayRef1(mclVsv(ind, "ind"), v_ + 1)),
                              _mxarray8_),
                            NULL),
                          mclPlus(
                            mclPlus(mclVa(np, "np"), mlfScalar(v_0)),
                            mclMtimes(mlfScalar(v_ - 1), _mxarray7_)));
                        mclArrayAssign2(
                          J,
                          mclMrdivide(
                            mclMinus(
                              mclVe(
                                mclArrayRef2(
                                  mclVsv(g, "g"),
                                  mlfCreateColonIndex(),
                                  _mxarray9_)),
                              mclVe(
                                mclArrayRef2(
                                  mclVsv(r, "r"),
                                  mlfCreateColonIndex(),
                                  _mxarray9_))),
                            mclVv(delta, "delta")),
                          mlfColon(
                            mclPlus(
                              mclVe(mclIntArrayRef1(mclVsv(ind, "ind"), v_)),
                              mclMrdivide(mclVv(m, "m"), _mxarray9_)),
                            mclPlus(
                              mclMinus(
                                mclVe(
                                  mclIntArrayRef1(mclVsv(ind, "ind"), v_ + 1)),
                                _mxarray8_),
                              mclMrdivide(mclVv(m, "m"), _mxarray9_)),
                            NULL),
                          mclPlus(
                            mclPlus(mclVa(np, "np"), mlfScalar(v_0)),
                            mclMtimes(mlfScalar(v_ - 1), _mxarray7_)));
                        if (v_0 == e_0) {
                            break;
                        }
                        ++v_0;
                    }
                    mlfAssign(&i, mlfScalar(v_0));
                }
                if (v_ == e_) {
                    break;
                }
                ++v_;
            }
            mlfAssign(&j, mlfScalar(v_));
        }
    }
    /*
     * J=sparse(J);
     */
    mlfAssign(J, mlfSparse(mclVv(*J, "J"), NULL, NULL, NULL, NULL, NULL));
    /*
     * f=f(:);
     */
    mlfAssign(&f, mclArrayRef1(mclVsv(f, "f"), mlfCreateColonIndex()));
    mclValidateOutput(f, 1, nargout_, "f", "jacobc");
    mclValidateOutput(*J, 2, nargout_, "J", "jacobc");
    mxDestroyArray(delta);
    mxDestroyArray(n);
    mxDestroyArray(t);
    mxDestroyArray(ind);
    mxDestroyArray(m);
    mxDestroyArray(i);
    mxDestroyArray(q);
    mxDestroyArray(g);
    mxDestroyArray(j);
    mxDestroyArray(r);
    mxDestroyArray(cpar);
    mxDestroyArray(np);
    mxDestroyArray(p);
    mxDestroyArray(nbr);
    mxDestroyArray(mod);
    mxDestroyArray(sys);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
    return f;
}
