//colorconversion.h
//contains a few sample routines for converting
//images to different color depths, etc
//aroetter@graphics
#include "Image.h"


#ifdef __cplusplus
extern "C"
{
#endif
//goes from rgb to greyscale, where every pixel is either
//black(0) or white(255)
/* converts a color image down to 2 bit, using a simple threshold
 * dither, the color to use is given by argument color, where
 *red = 0, green = 1, blue = 2
 * and the threshold value is give by the other variable, and can be between
 * 0 and 255
 */
//rgbimg must be 3 dimensional rgb and img must be 1d
//need to test this function
void binarygrayscale(Image &rgbimg, Image &bwimg,
		     int color, int threshold);


//goes from rgb to gray, where gray values are 0-255
void color2grayscale(Image &color, Image &gray);




#ifdef __cplusplus
}
#endif
