// a header file for the hough code by kari
// -aroetter@graphics 4/15/98

#ifndef _HOUGH_H_
#define _HOUGH_H_

#include "Image.h"
#include "vector"
#include "Coord.h"
using namespace std;
//find the circle centers in the calibration patterm
//numbers of circles per row, and per column
//rows and columns are the numbers of circles in both directions
//R is the estimated radius, in pixels, of a circle, 
//and dR is the spacing between two adjacent circles
//ie from the right side of a circle to the leftmost part of the
//circle to its immediate right
void findCenters(int rows, int cols, int R, int dR,
		 Image& img,
		 Image& rgbimg, vector<Coord>& pts);

#endif //_HOUGH_H_
